/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.util;

import de.steamwar.bausystem.BauSystem;
import de.steamwar.command.SWCommand;
import de.steamwar.linkage.Linked;
import de.steamwar.linkage.LinkedInstance;
import org.bukkit.entity.Player;

import java.util.HashSet;
import java.util.Set;
import java.util.UUID;

@Linked
public class PistonCalculatorCommand extends SWCommand {

    @LinkedInstance
    public PistonCalculator pistonCalculator;

    private final Set<UUID> helpMessageShowed = new HashSet<>();

    public PistonCalculatorCommand() {
        super("piston", "pistoncalculator", "pistoncalc");
    }

    @Register
    public void genericCommand(@Validator Player player) {
        if (pistonCalculator.disablePistonCalculator.contains(player)) {
            pistonCalculator.disablePistonCalculator.remove(player);
            if (!helpMessageShowed.contains(player.getUniqueId())) {
                BauSystem.MESSAGE.send("PISTON_HELP_1", player);
                BauSystem.MESSAGE.send("PISTON_HELP_2", player);
                BauSystem.MESSAGE.send("PISTON_HELP_3", player);
                helpMessageShowed.add(player.getUniqueId());
            }
            BauSystem.MESSAGE.send("PISTON_ENABLED", player);
        } else {
            pistonCalculator.disablePistonCalculator.add(player);
            BauSystem.MESSAGE.send("PISTON_DISABLED", player);
        }
    }

    @Register("clear")
    public void clearCommand(@Validator Player player) {
        pistonCalculator.clear(player);
    }
}
